<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Download Input Files</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.min.css" crossorigin="anonymous">

    <link href="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/piexif.min.js" type="text/javascript"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/sortable.min.js" type="text/javascript"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/fileinput.min.js"></script>
    <script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/locales/LANG.js"></script>
    <link href="../static/styles/upload_file.css" rel="stylesheet">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.form/4.3.0/jquery.form.min.js" integrity="sha384-qlmct0AOBiA2VPZkMY3+2WqkHtIQ9lSdAsAn5RUJD/3vA5MKDgSGcdmIv4ycVxyn" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>




</head>
<body>


    <nav class="navbar navbar-expand-md navbar-light bg-light">
        
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mx-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="/">Home</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('submit_workflow')}}">Submit Workflow</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('workflow_metadata')}}">Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('group_workflow_metadata')}}">Group Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{url_for('inputs')}}">Input Files</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{url_for('outputs')}}">Output Files</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('logout')}}"> <b>Logout</b> </a>
                </li>

            </ul>
        </div>
    </nav>


<br>
<div class="form-center">
    <b> Insert referral number in order to retrieve input files that were used </b>
</div>

<div class="container">
    <div class="mb-3">
        <label for="marks" class="form-label">Referral Number</label>
        <input type="text" name="ref_number" class="form-control" id="ref_number" aria-describedby="ref_number" placeholder="123-456-789">
    </div>
    <br>
    {% set access_token = data["access_token"] %}
    <div class="form-center">
        <button onclick="download('{{access_token}}');" type="submit" class="btn btn-primary" style="width: 25%" >Download</button>  
    </div>

    <button class="btn btn-primary d-none" id="loading_btn" type="button" disabled>
        <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
        Downloading...
    </button>
    <br>
    <br>
    <div id="alert_wrapper"></div>

    
</div>

<script>
  
  function show_alert(message, alert) {
    alert_wrapper.innerHTML = `
        <div id="alert" class="alert alert-${alert} alert-dismissible fade show" role="alert">
        <span>${message}</span>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
        </div>
    `
    }

    function download(access_token){
        var loading_btn = document.getElementById("loading_btn");
        var ref_number = document.getElementById("ref_number");
        if(!ref_number.value){
            show_alert("No referral number provided", "warning");
            return;
        }
        loading_btn.classList.remove("d-none");

        var request = new XMLHttpRequest();
        request.open("get", "https://rest.workflow-service.dev-greecevscorona.iit.demokritos.gr/inputs?ref_number="+ref_number.value);
        request.setRequestHeader("Authorization", 'Bearer '+ access_token);
        request.responseType = "arraybuffer";

        request.send();

        request.addEventListener("load", function (e) {
            if (request.status == 200) {
                show_alert(`Input files for ${ref_number.value} were succesfully downloaded`, "success");
                var blob = new Blob([this.response], {type: 'octet/stream'});
                let a = document.createElement("a");
                a.style = "display: none";
                document.body.appendChild(a);
                let url = window.URL.createObjectURL(blob);
                a.href = url;
                a.download = 'inputs.zip';
                a.click();
                window.URL.revokeObjectURL(url);
                loading_btn.classList.add("d-none");

                
            }
            else if (request.status == 401){
                show_alert(`Your session has expired. Please login again` , "danger");
                loading_btn.classList.add("d-none");

            }
            else {
                if (request.status == 404){
                    show_alert(`No workflows found for referral number ${ref_number.value}` , "danger");
                }
                else if (request.status == 402){
                    show_alert(`Workflow with referral number ${ref_number.value} belongs to another group`,"danger");
                }
                else if (request.status == 403){
                    show_alert(`Workflow with referral number ${ref_number.value} must have Succeeded status in order to get input files`,"danger");
                }
                loading_btn.classList.add("d-none");



            }

            });



    }


  
</script>


</body>

</html>

